/* Initialization */
#include "Obstacle_model.h"
#include "Obstacle_11mix.h"
#include "Obstacle_12jac.h"
#if defined(__cplusplus)
extern "C" {
#endif

void Obstacle_functionInitialEquations_0(DATA *data, threadData_t *threadData);


/*
 equation index: 1
 type: SIMPLE_ASSIGN
 compression = disp - fixed_x
 */
void Obstacle_eqFunction_1(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH
  const int equationIndexes[2] = {1,1};
  data->localData[0]->realVars[0] /* compression variable */ = data->localData[0]->realVars[1] /* disp variable */ - data->simulationInfo->realParameter[1] /* fixed_x PARAM */;
  TRACE_POP
}

/*
 equation index: 2
 type: SIMPLE_ASSIGN
 reaction_force = if disp > fixed_x then c * compression else 0.0
 */
void Obstacle_eqFunction_2(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH
  const int equationIndexes[2] = {1,2};
  modelica_boolean tmp0;
  tmp0 = Greater(data->localData[0]->realVars[1] /* disp variable */,data->simulationInfo->realParameter[1] /* fixed_x PARAM */);
  data->localData[0]->realVars[2] /* reaction_force variable */ = (tmp0?(data->simulationInfo->realParameter[0] /* c PARAM */) * (data->localData[0]->realVars[0] /* compression variable */):0.0);
  TRACE_POP
}
void Obstacle_functionInitialEquations_0(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH
  Obstacle_eqFunction_1(data, threadData);
  Obstacle_eqFunction_2(data, threadData);
  TRACE_POP
}


int Obstacle_functionInitialEquations(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH

  data->simulationInfo->discreteCall = 1;
  Obstacle_functionInitialEquations_0(data, threadData);
  data->simulationInfo->discreteCall = 0;
  
  TRACE_POP
  return 0;
}


int Obstacle_functionInitialEquations_lambda0(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH

  data->simulationInfo->discreteCall = 1;
  data->simulationInfo->discreteCall = 0;
  
  TRACE_POP
  return 0;
}
int Obstacle_functionRemovedInitialEquations(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH
  const int *equationIndexes = NULL;
  double res = 0.0;

  
  TRACE_POP
  return 0;
}


#if defined(__cplusplus)
}
#endif

